char *inslines[] = {
"                 Instructions for the genealogy database.",
"",
"Type `q' at any point (including these instructions) to quit this program.",
"type `.' at any point to return to the main screen.",
"Type `?' at the main screen to receive a brief list of the available commands.",
"Type `I' at the main screen to review these instructions from within the",
"program.  You will be given an opportunity to print these instructions",
"on your local printer, or save them in a file.",
"",
"The `main screen' displays the current person's name and birthdate,",
"along with his immediate relatives (parents, children, and spouses).",
"At any point, the character `.' aborts any data entry in progress",
"and returns you to the main screen.  Each time you change the current person",
"by moving to a new person or adding a relative, the program",
"presents the new main screen.  Here is an example screen:",
"",
"George J Jetson 7/3/2603-12/29/2689",
"Born in Technoville California",
"Parents: John and Martha Jetson",
"Married to: Jane 2624",
"children: Judy Elroy",
"-",
"Despite my attempts to be pneumonic, new users will sometimes forget the",
"key/command mappings.  When the main screen asks you for the next action,",
"don't hesitate to ask for help by hitting `?'.",
"The following summary screen appears:",
"",
"     hwfmc   Move to husband, wife, father, mother, child.",
"     oy      Move to an older or younger sibling.",
"     1-9     Move to one of the children, ordered by birth.",
"     p       Move to a new (possibly unrelated) person.",
"     HWFMCS  Add a husband, wife, father, mother, child, or sibling.",
"     P       Add an unrelated person.",
"     >       Activate adoption/caregiving mode.",
"     q       quit this program.",
"     .       abort any data entry in progress and return to the main screen.",
"     ?       Print a help synopsis, the one you are currently reading.",
"     I       Read the instructions for this program.",
"     t       Review, update, or add text entries.",
"     u       Update shortnotes, names, or dates.",
"     +      Merge this person with another, the two become one.",
"     Z      Zap (remove) a person's links from the database.",
"-",
"This database stores and maintains your family tree,",
"an arrangement of people linked by birth and marriage.",
"The program concentrates on one person at a time, the `current' person.",
"If the current person is John Smith, type `f' to move up to Harold Smith,",
"John's father, or type `m' to move up to Wilma Martin, John's mother.",
"Note that maiden or birth names are always used.",
"Type `h' for husband, `w' for wife, and `c' for child.",
"Type `o' to move to an older sibling and `y' to move to a younger sibling.",
"This transfer is made through the father if possible, or through the mother",
"if there is no father linked to the current person.",
"",
"If John has 7 children, `c2' takes you to the second child, ordered by birth.",
"Similarly, `h2' means the second husband and `w3' means the third wife.",
"If there is only one child (or husband or wife)",
"the digit `1' is not required.",
"The entered digit `4' is shorthand for `c4', and jumps to the fourth child.",
"Using the letters `hwfmcyo' and the digits 1 through 9,",
"you can quickly traverse your family tree.",
"-",
"If John's father has not yet been entered into the database,",
"type `F' to add his father.",
"The program prompts you for the name, birthdate, etc.",
"In the same fashion, type `M' to add his mother,",
"`H' for a new husband, `W' for a wife, `C' for a child, and `S' for a sibling.",
"Again, siblings are created as children of  the father,",
"or the mother if the father is not present in the database.  In summary,",
"small letters traverse the tree and capital letters add to the tree.",
"Use `f' to move to the father, `F' to create the father.",
"",
"When a new name is entered in all upper or lower case, the program converts",
"it to mixed case using a very simple algorithm.",
"If you wish to override this conversion, enter the name in mixed case.",
"Names may also contain dashes or apostrophes, such as Smith-Martin or O'Clark.",
"To embed spaces in the first or last name, use slashes to specifically",
"delimit the three fields:  `John/Alan/De Witt'.",
"",
"Dates may be entered as `12 29 1963' or `12/29/1963'.",
"If you are unsure of the exact date, simply enter the year.",
"If you cannot even make a guess at the year, hit return and the program",
"will store a null date.",
"-",
"When you link John to his new father by hitting `F', you may either create",
"a new person or select a person that already exists in the database.  Perhaps",
"you have already enterred his father as somebody else's husband or child.",
"The more incest, the more often you will need to link to preexisting people.",
"",
"When the program asks for the name of John's father,",
"begin with a `*' if you are selecting a preexisting person in the database.",
"The program finds this person by name and establishes the paternal link.",
"You may enter name fragments if you are unsure of the exact spelling,",
"or you simply want to save typing.  Of course the complete name yields",
"a faster and more focused search.",
"If the name does not begin with a `*', the program creates",
"a new person under the entered name and links him to the current person.",
"",
"I assume each local database is well understood by a few individuals,",
"and these users know whether they need to enter a new person",
"or reference a preexisting person.",
"Hence this name-entry interface does not generalize to large multi-user",
"databases housing separate genealogies that collide in their ancestry.",
"A large centralized global database must employ an automatic search mechanism.",
"The design of such a database is beyond the scope of these instructions.",
"-",
"When adding a child to a man, the program automatically infers",
"the last name.  It asks for first and middle name only.",
"Include a last name if you want to override the inheritted last name.",
"When you link a child to a woman, or add a spouse or mother,",
"the program asks for the full name.",
"Therefore it is easier to add children to the father than the mother.",
"",
"Whenever a full name is requested, always enter the birth or maiden name.",
"When linking to an existing person via the search `*' feature, always enter",
"first and last name, even if the program asks for first and middle name.",
"",
"When adding a child to one couple of a marriage, the program",
"automatically asks whether the most recent spouse is also the child's parent.",
"Thus the second link is established simply by typing `y'.",
"If you create a marriage, and either partner",
"has children without two parents, the program asks whether the new spouse",
"is the child's second parent.  Thus all links",
"are established when a person is first entered into the database.",
"-",
"In general it is easiest to start with the father of a family `unit'.",
"Add the first wife using `W', and then type `h' to return to the husband.",
"Type `C' to create the first child and type `S'",
"thereafter until all the siblings are enterred.",
"You need never enter the last names of the children, as they are linked to the",
"father, and the maternal links are established simply by hitting `y'.",
"Then type `f' to return to the father and hit `W' to create his second wife.",
"Jump back to the father and add all the children he had with his second wife.",
"Repeat this process until you have enterred all the members of his",
"immediate family.",
"Of course this approach is merely a convenience that may save some typing;",
"people can be added in any order.",
"-",
"Type `p' at the main screen to jump to a different person.",
"This person may be completely unrelated to the current person.",
"The search feature is automatically envoked; you need not prepend a `*'",
"to the entered name.  Type `P' to create an unrelated person.",
"",
"Type `u' to update the names, dates, or shortnotes associated with the current",
"person.  The database stores multiple names and aliases,",
"including maiden and married names, primarily for search purposes.",
"You may correct the spelling of an existing name,",
"add a new name, correct a birthdate, or add a deathdate.",
"The update routines are self-explanatory.",
"",
"If a person is inadvertantly linked to the wrong people, use the zap `Z'",
"command to remove these links (birth or marriage).  Then establish the correct",
"links by using the search `*' feature to find his relatives in the database.",
"If the current person is already isolated, the `Z' command deletes him",
"from the database, as though he were never enterred.",
"In either case the program describes the consequences of the `Z' command",
"and asks whether you really want to procede.",
"-",
"At this point the genealogy system still has some glaring omitions.",
"If a child's parents divorce early and then remarry,",
"there is no way to know which new spouse acts as the child's (virtual) parent.",
"In short, who got custidy and which couple raised this child?",
"You could add a note that describes the situation,",
"but this approach is not very appealling.",
"Furthermore, if a child is adopted, and the birth mother is not known,",
"there is no way to link the child to anybody in the database.",
"You could establish a maternal link and add a note",
"describing the adoption, but this is very misleading.",
"One should not have to peruse text entries to make sure the various links mean",
"what they say.  In other cases, a child may have a birth mother",
"and several foster parents in succession.",
"Clearly some kind of multiple birth/adopting parent mechanism is required.",
"",
"A `caregiving' modifier, indicated by the symbol `>', allows you to link",
"a mother or father to a child as a guardian rather than a birth parent.",
"This may be a legal adoption, but it need not be,",
"especially since these legal procedures are a relatively recent phenominon,",
"rarely observed in the case of stepchildren or extended family care.",
"-",
"The main screen displays the current person's birth parents if known, but it",
"also lists any additional caregiving parents linked to this person.",
"Remember that the word `caregiving' is much more general than a formal",
"legal adoption, and may refer to a grandparent, a stepfather,",
"or anyone else who plays a significant caregiving roll in the child's life.",
"If caregiving parents are present, you can jump to a caregiving mother",
"by typing `>m', or a caregiving father via `>f'.",
"Thus the `>' symbol changes the sense of the subsequent command.",
"If there are several caregiving parents, you may need to type `>m3' to find",
"the third foster mother.  Caregivers are ordered by date of guardianship.",
"",
"When the main screen displays the children, any child who is linked",
"through a caregiving relationship has the character `>' prepended to his name.",
"You do not need to type `>c' to jump to an adopted or step child;",
"all children are accessible via the general `c' mechanism.",
"",
"Barney M Rubble 7/2/-39343",
"Born in Bedrock USA",
"Married to: Betty -39323",
"Children: >Bambam",
"-",
"To add a caregiving mother, type `>M'.  You can only create one mother,",
"but each person can have many caregiving parents.",
"Type `>F' to add a stepfather, or `>C' to add an adopted child.",
"",
"As mentioned earlier, any references to siblings",
"link through the birth father, or the birth mother if the",
"father is unknown.  Beyond this, the program does not attempt to guess which",
"caregiver (if any) you want to vector through when referencing a sibling.",
"After all, a child might stay in several foster homes, each",
"possessing an array of birth and adopted children.",
"As an unfortunate consequence, it is not very easy to traverse the members",
"of a large adopting family.  I believe this complexity is inherent in",
"the system of relationships being modelled, and is largely unavoidable.",
"-",
"As mentioned earlier, you may add a `*' to the beginning of a name",
"to search for a preexisting person in the database.",
"If that person is closely related to the current person,",
"an alternate access method may prove more convenient.",
"The symbol `@' causes the following string of characters",
"to be interpreted as literal keystrokes,",
"as though you had typed them in at the main screen.",
"Thus `@mm' refers to your maternal grandmother,",
"`@fy' is your uncle, `@w1f' is your father-in-law (via a first marriage),",
"and `@>mc3' is your stepmother's third child.",
"",
"Since people often name their children after themselves,",
"even a small database might have dozens of people with the same name,",
"making name searches inconvenient.",
"Usually the person you seek is a close relative, someone who acts",
"as caregiver for the current person.",
"To assert that a grandmother helped raise a child,",
"simply type `>M@mm'.",
"If your mother's third husband acted as stepfather, type `>F@mh3'.",
"To marry your cousin, type `H@fyy3'.",
"-",
"As any high school student knows, history is extremely dull if reduced to",
"names, places, and dates.  Therefore this database stores text entries",
"and associates them with individuals.  Each entry is assigned a ",
"type: diary, correspondence, information from a third party, or a publication",
"such as a paper or a relevant newspaper clipping.",
"Each text entry may also be assigned a date, if it refers to a specific event,",
"or if it was written on a certain date (e.g. a letter).",
"Undated entries are usually informational in nature, describing",
"the individual as a whole, rather than a particular event in his life.",
"As a compromise between huge files and thousands of tiny files,",
"all undated entries are stored in one file, and dated entries",
"are partitioned into separate files based upon the year.",
"-",
"Hit `t' at the main screen to read",
"these text entries or insert new ones.  The program asks you for a date,",
"and then gathers 50 text entries starting with the date specified, and",
"restricted to that year (since text entries are archived internally by year).",
"Simply hit return if you wish to view the undated entries.",
"",
"The types and dates of the collected entries are displayed in a 5 by 10 grid.",
"You may select one of these text entries for review or edit",
"by using battleship notation, with a1 in the upper left.",
"Type a* to review all 10 text entries on the first row at once.",
"Since many diary entries are only one or two lines long,",
"it is much more convenient to view ten at a time.",
"The program places all 10 entries in a text file,",
"delimitted by headings that indicate the date of each entry.",
"You may review these ten entreis using your edittor, but you cannot",
"make any revisions.  Only individual text entries can be updated.",
"To delete a text entry, simply remove all the text, leaving an empty file.",
"The text entry system prompts you at each step, and is self-explanatory.",
"-",
"When you review, update, or add a text entry, the program throws",
"you into the `ed' editor under UNIX, and `edlin' under MSDOS.",
"If you are unfamiliar with these editors you will be very frustrated.",
"Override these defaults by setting the environment variable ED:",
"set ED=emacs (MSDOS) export ED=emacs (UNIX).",
"",
"The database successfully swallows all text formats,",
"including Word Perfect and Wordstar files.",
"However, I strongly encourage the use of ASCII text edittors.",
"Your specific word processor might be extinct 300 years from now,",
"but ASCII text files will always be accessible.",
"-",
"If you already have diary entries or letters in electronic form, there is no",
"need to rekey this data.",
"To turn a preexisting letter into a text entry,",
"invoke the text entry system, establish the date,",
"and tell the program that you would like to add a new entry.",
"When it places you in your editor, simply load the preexisting file.",
"Since the program first changes directories, moving to your `gng' directory,",
"you should probably use absolute pathnames when referencing files.  Issue",
"the write command and quit your editor, and the letter becomes a text entry.",
"",
"If you have hundreds of small entries on line",
"(e.g. a years worth of diary entries),",
"and you don't want to stumble through the text entry system",
"to incorporate each journal entry individually,",
"collect the diary entries for a given year in a",
"line-oriented ASCII file and delimit these entries with lines of the form",
"d>04/23     to initiate a diary entry on April 23.",
"Then run `gng textin'.  The program prompts for the person, the year,",
"and the prepared file containing the text entries for that year.  See the",
"`gng.doc' file for more documentation on this administrative command.",
"-",
"Several aspects of a person's life are of general interest, and can be",
"summarized quickly.  These include place of birth, circumstances of death,",
"occupation, ethnic heritage, etc.",
"It is rather tedious to invoke the text entry system just to record",
"or retrieve someone's occupation.",
"Therefore, this database stores several shortnotes for each person,",
"each note consisting of one line of text.",
"The main screen presents only the birth note, as this is useful",
"for identification purposes, but all short notes appear on the generated",
"printouts, since these printouts should provide a brief summary of each person.",
"See the `gng.doc' file for more details on the printout command.",
"Type `us' to update and/or review",
"the short notes linked to the current person.",
"-",
"The ultimate (and perhaps optimistic) goal of this program is the eventual",
"consolidation of databases, with a minimum of human intervention and rekeying.",
"The `+' command represents the first implementation of a person merge",
"capability.  The program prompts you for a second person,",
"someone whom you have decided is the same as the current person.",
"The merge will abort if the two individuals have different genders,",
"or if the new merged individual would have multiple fathers or mothers,",
"a condition that represents a corrupt database.",
"The program merges the two individuals, combining and merging",
"their associated data.  The system prompts you whenever ambiguities",
"must be resolved (e.g. the two individuals have different birthdates).",
"Links to relatives are simply regrouped.",
"Hence if one person has 3 children and another has 4,",
"and they are merged, the resulting person has 7 children.",
"Text entries are also combined, but in a very simplistic fashion.",
"The entries for a given year, or the undated entries, must come from one",
"individual or another.  When a collision occurs, you must decide",
"whose text entries to keep and whose will be lost.",
"In practice this simple algorithm is sufficient,",
"since one source usually generates and maintains text entries for a given",
"individual.",
"-",
"After two people are merged, the program attempts to merge their respective",
"relatives recursively.  Thus entire family trees melt together.",
"The program may ask you whether two individuals should be merged or not,",
"especially near the leaves of the tree where information is sparse.",
"Within the tree there is much more data, such as the names and birthdates",
"of children and spouses, and the program can usually run autonomously.",
"The administrative `foldin' command, described in the `gng.doc' file,",
"adds data from a remote source into your database.",
"It then asks whether you want to follow this with a merge operation.",
"If you have accepted data from this source before, hit `y'.",
"The program tries to find a match between someone that was added and",
"someone in your original database.  It starts the merge at this point,",
"and then merges relatives recursively, as described above.",
"This is the capability that allows separate individuals to research",
"different branches of their family, and merge",
"the results together every few months to maintain a central database.",
"I hope these concepts will eventually generalize to",
"a world-wide database that anybody can contribute to,",
"simply by transmitting a local database over the internet,",
"destined for automatic integration at a central site.",
0};
